/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  org.apache.poi.hssf.util.HSSFColor
 */
package com.jiuqi.office.excel;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.apache.poi.hssf.util.HSSFColor;

public class HSSFHelper {
    private static final int[] WIN32_COLORS;
    private static List colorElements;
    private static Map colorFinder;

    static {
        int[] nArray = new int[32];
        nArray[0] = 0xC8C8C8;
        nArray[2] = 13743257;
        nArray[3] = 14405055;
        nArray[4] = 0xF0F0F0;
        nArray[5] = 0xFFFFFF;
        nArray[6] = 0x646464;
        nArray[10] = 0xB4B4B4;
        nArray[11] = 16578548;
        nArray[12] = 0xABABAB;
        nArray[13] = 0xFF9933;
        nArray[14] = 0xFFFFFF;
        nArray[15] = 0xF0F0F0;
        nArray[16] = 0xA0A0A0;
        nArray[17] = 0x808080;
        nArray[19] = 5525059;
        nArray[20] = 0xFFFFFF;
        nArray[21] = 0x696969;
        nArray[22] = 0xE3E3E3;
        nArray[24] = 0xE1FFFF;
        nArray[26] = 0xCC6600;
        nArray[27] = 15389113;
        nArray[28] = 15918295;
        nArray[29] = 0xFF9933;
        nArray[30] = 0xF0F0F0;
        WIN32_COLORS = nArray;
        colorElements = new ArrayList();
        colorFinder = new Hashtable();
    }

    private HSSFHelper() {
    }

    public static int pixelToWidth(int value) {
        if (value <= 0) {
            return 0;
        }
        if (value == 1) {
            return 19;
        }
        int width = 19;
        width += --value / 7 * 256;
        int delta = value % 7;
        if (delta > 0) {
            width += delta / 2 * 73;
            if (delta % 2 == 1) {
                width += 37;
            }
        }
        return width;
    }

    public static int widthToPixel(short value) {
        return (short)(value / 32);
    }

    public static short pixelToHeight(int value) {
        if (value <= 0) {
            return 0;
        }
        int height = 7 + (value - 1) * 15;
        return (short)height;
    }

    public static int heightToPixel(short value) {
        return value / 15;
    }

    public static HSSFColor getApproximateColor(int rgbColor) {
        Integer key = new Integer(rgbColor);
        HSSFColor retColor = (HSSFColor)colorFinder.get(key);
        if (retColor == null && (retColor = HSSFHelper.findApproximateColor(rgbColor)) != null) {
            colorFinder.put(key, retColor);
        }
        return retColor;
    }

    public static int getRGBColor(HSSFColor hssfColor) {
        short[] rgb = hssfColor.getTriplet();
        return rgb[0] << 16 | rgb[1] << 8 | rgb[2];
    }

    public static int getRGBColor(short index) {
        HSSFColor hssfColor = (HSSFColor)HSSFColor.getIndexHash().get(new Integer(index));
        if (hssfColor != null) {
            return HSSFHelper.getRGBColor(hssfColor);
        }
        return -1;
    }

    public static HSSFColor getApproximateTextColor(int rgbColor) {
        if (rgbColor == -16777211) {
            rgbColor = 0;
        }
        return HSSFHelper.getApproximateColor(rgbColor);
    }

    public static HSSFColor getApproximateEdgeColor(int rgbColor) {
        if (rgbColor == -16777201) {
            rgbColor = 0x808080;
        }
        return HSSFHelper.getApproximateColor(rgbColor);
    }

    /*
     * WARNING - Removed try catching itself - possible behaviour change.
     */
    private static void buildColorList() {
        List list = colorElements;
        synchronized (list) {
            if (colorElements.size() == 0) {
                Map colorMaps = null;
                colorMaps = HSSFColor.getIndexHash();
                Collection colorList = colorMaps.values();
                Iterator colorItr = colorList.iterator();
                while (colorItr.hasNext()) {
                    ColorElement element = new ColorElement();
                    element.color = (HSSFColor)colorItr.next();
                    short[] rgbVals = element.color.getTriplet();
                    element.rgb = HSSFHelper.rgbToColor(rgbVals[0], rgbVals[1], rgbVals[2]);
                    element.hsb = HSSFHelper.color2HSB(element.rgb);
                    colorElements.add(element);
                }
            }
        }
    }

    private static HSSFColor findApproximateColor(int rgbColor) {
        HSSFHelper.buildColorList();
        HSB Hsb = HSSFHelper.color2HSB(rgbColor);
        double L = Math.sqrt(20000.0);
        ColorElement flagElement = null;
        int i = 0;
        while (i < colorElements.size()) {
            double E;
            ColorElement elem = (ColorElement)colorElements.get(i);
            if (rgbColor == elem.rgb) {
                return elem.color;
            }
            double Q = Hsb.h - elem.hsb.h;
            if (Q > 180.0) {
                Q = 360.0 - Q;
            }
            if (L > (E = Math.sqrt(Math.pow(elem.hsb.s - Hsb.s, 2.0) + Math.pow(elem.hsb.b - Hsb.b * Math.cos(Q * Math.PI / 180.0), 2.0) + Math.pow(Hsb.b * Math.sin(Q * Math.PI / 180.0), 2.0)))) {
                L = E;
                flagElement = elem;
            }
            ++i;
        }
        if (flagElement == null) {
            return null;
        }
        return flagElement.color;
    }

    private static int rgbToColor(int r, int g, int b) {
        return (r <<= 16) | (g <<= 8) | b;
    }

    private static HSB color2HSB(int value) {
        HSB hsb = new HSB();
        RGB rgb = HSSFHelper.colorToRGB(value);
        double M0 = (double)HSSFHelper.maxColorValue(rgb) / 2.55;
        hsb.setDefault();
        hsb.b = M0;
        if (hsb.b == 0.0) {
            hsb.s = 0.0;
        } else {
            double M1 = (double)HSSFHelper.minColorValue(rgb) / 2.55;
            hsb.s = (M0 - M1) * 100.0 / M0;
        }
        hsb.h = HSSFHelper.RGBToHue(rgb);
        return hsb;
    }

    private static RGB colorToRGB(int value) {
        if (value < 0) {
            value = WIN32_COLORS[value & 0xFF];
        }
        int r = (value & 0xFF0000) >> 16;
        int g = (value & 0xFF00) >> 8;
        int b = value & 0xFF;
        return new RGB(r, g, b);
    }

    private static double RGBToHue(RGB rgb) {
        double H;
        int M2;
        int M0 = HSSFHelper.minColorValue(rgb);
        if (M0 == (M2 = HSSFHelper.maxColorValue(rgb))) {
            return 0.0;
        }
        int M1 = HSSFHelper.centerColorValue(rgb);
        if (M2 == M1) {
            if (rgb.r == rgb.g) {
                return 60.0;
            }
            if (rgb.g == rgb.b) {
                return 180.0;
            }
            return 300.0;
        }
        double F = 60 * (M1 - M0) / (M2 - M0);
        if (rgb.r == M2) {
            H = rgb.g < rgb.b ? -F : F;
        } else if (rgb.g == M2) {
            H = rgb.b < rgb.r ? -F : F;
            H += 120.0;
        } else {
            H = rgb.r < rgb.g ? -F : F;
            H += 240.0;
        }
        if (H < 0.0) {
            H += 360.0;
        }
        return H;
    }

    private static int maxColorValue(RGB rgb) {
        int max = rgb.r;
        if (rgb.g > max) {
            max = rgb.g;
        }
        if (rgb.b > max) {
            max = rgb.b;
        }
        return max;
    }

    private static int minColorValue(RGB rgb) {
        int min = rgb.r;
        if (rgb.g < min) {
            min = rgb.g;
        }
        if (rgb.b < min) {
            min = rgb.b;
        }
        return min;
    }

    private static int centerColorValue(RGB rgb) {
        if (rgb.r < rgb.g && rgb.r < rgb.b) {
            if (rgb.g < rgb.b) {
                return rgb.g;
            }
            return rgb.b;
        }
        if (rgb.g < rgb.r && rgb.g < rgb.b) {
            if (rgb.r < rgb.b) {
                return rgb.r;
            }
            return rgb.b;
        }
        if (rgb.r < rgb.g) {
            return rgb.r;
        }
        return rgb.g;
    }

    protected static class ColorElement {
        public int rgb;
        public HSB hsb;
        public HSSFColor color;

        protected ColorElement() {
        }
    }

    protected static class HSB {
        public double h;
        public double s;
        public double b;

        protected HSB() {
        }

        public void setDefault() {
            this.h = 65535.0;
            this.s = 0.0;
            this.b = 0.0;
        }
    }

    private static class RGB {
        public int r;
        public int g;
        public int b;

        public RGB() {
        }

        public RGB(int r, int g, int b) {
            this.r = r;
            this.g = g;
            this.b = b;
        }
    }
}

